/******************************************************************************
;  *   	@ͺ				  : MC32P8141
;  *   	@             : 2021.08.04
;  *   	@˾/			  : SINOMCU-FAE
;  *   	@΢֧       : 2048615934
;  *   	@΢           : http://www.sinomcu.com/
;  *   	@Ȩ                 : 2021 SINOMCU˾Ȩ.
;  *----------------------ժҪ---------------------------------
;  *   	   	   	        
                P00 жϻ
                T1 ʱ1mS P17ת  2S
******************************************************************************/

#include "user.h"

/************************************************
;  *    @Function Name       : CLR_RAM
;  *    @Description         : 
;  *    @IN_Parameter        :
;  *    @Return parameter    :
;  ***********************************************/
void CLR_RAM(void)
{
__asm 
    movai 0x7F 
    movra FSR0
    clrr INDF0
    DJZR FSR0 
    goto $ -2
    clrr INDF0
__endasm;
}
/************************************************
;  *    @Function Name       : IO_Config
;  *    @Description         : ioڳʼ
;  *    @IN_Parameter      	 : 
;  *    @Return parameter    :
;  ***********************************************/
void IO_Init(void)
{
    IOP0 = 0x00; //ioλ
    OEP0 = 0xfE; //ioڷ 1:out  0:in   	P00 in
    PUP0 = 0x01; //io   1:enable  0:disable   P00 up
    PDP0 = 0x00; //io   1:enable  0:disable

    IOP1 = 0x00; //ioλ
    OEP1 = 0xff; //ioڷ 1:out  0:in
    PUP1 = 0x00; //io   1:enable  0:disable
    PDP1 = 0x00; //io   1:enable  0:disable

    P0ADCR = 0x00; //˿ģ   1:ģ  0:
    P1ADCR = 0x00; //˿ģ   1:ģ  0:

}
/************************************************
;  *    @Function Name       : KBIM_Init
;  *    @Description         : жϳʼ
;  *    @IN_Parameter      	 : 
;  *    @Return parameter    :
;  ***********************************************/
void KBIM_Init(void)
{
    P00KE=1;        //ʹP00ж
}
 /************************************************
 ;  *    @Function Name       : TIMER1_INT_Init
 ;  *    @Description         : ʱʼ
 ;  *    @IN_Parameter        :
 ;  *    @Return parameter    :
 ;  ***********************************************/
 void TIMER1_INT_Init(void)
 {
     T1CR = 0x85;  	//ʹT1رPWMʱΪFCPU32Ƶ
     T1CNT = 250-1;
     T1LOAD = 250-1;   	   	//1mS
     T1IE = 1;
 }
/************************************************
;  *    @Function Name       : Sys_Init
;  *    @Description         : ϵͳʼ
;  *    @IN_Parameter      	 : 
;  *    @Return parameter    :
;  ***********************************************/
void Sys_Init(void)
{
    GIE = 0;
    CLR_RAM();
    IO_Init();
    KBIM_Init();
    TIMER1_INT_Init();
    GIE = 1;
}
void main(void)
{
    Sys_Init();
    while (1)
    {
        if(FLAG_TIMER1_2000ms)      //2s
        {
            FLAG_TIMER1_2000ms = 0;
            GIE = 0;
            KBIE = 1;   //ʹܼжϻ
            P16D = 0;
            P17D = 0;     //ر
            Stop();
            Nop();
            Nop();
            KBIF=0;
            KBIE = 0;   //ر
            GIE = 1;
        }
        
    }
}

void int_isr(void) __interrupt
{
__asm 
   	movra _abuf
   	swapar _PFLAG
   	movra _statusbuf
__endasm;
    if (T0IF && T0IE)
    {
        T0IF = 0;
__asm 
   	   	MOVAI  	01000000B
   	   	XORRA  	IOP1   	 
__endasm;
   	   	//P16ת
    }
    if (T1IF && T1IE)
    {
        T1IF = 0;
__asm 
   	   	MOVAI  	10000000B
   	   	XORRA  	IOP1   	 
__endasm;
   	   	//P17ת
        timer1_cnt1++;
        if(timer1_cnt1 >= 2000)       //2s
        {
            timer1_cnt1 = 0;
            FLAG_TIMER1_2000ms = 1;
        }
    }

__asm 
   	swapar _statusbuf
   	movra _PFLAG
   	swapr _abuf
   	swapar _abuf
__endasm;
}
