/******************************************************************************
;  *   	@ͺ				  : MC32P8141
;  *   	@             : 2021.08.04
;  *   	@˾/			  : SINOMCU-FAE
;  *   	@΢֧       : 2048615934
;  *   	@΢           : http://www.sinomcu.com/
;  *   	@Ȩ                 : 2021 SINOMCU˾Ȩ.
;  *----------------------ժҪ---------------------------------
;  *   	   	   	         T2 PWM ʱΪFPFRC
                    T1ʱ10mS޸PFRCCAL  ΢32M
******************************************************************************/

#include "user.h"

/************************************************
;  *    @Function Name       : CLR_RAM
;  *    @Description         : 
;  *    @IN_Parameter        :
;  *    @Return parameter    :
;  ***********************************************/
void CLR_RAM(void)
{
__asm 
    movai 0x7F 
    movra FSR0
    clrr INDF0
    DJZR FSR0 
    goto $-2 
    clrr INDF0
__endasm;
}
/************************************************
;  *    @Function Name       : IO_Config
;  *    @Description         : ioڳʼ
;  *    @IN_Parameter      	 : 
;  *    @Return parameter    :
;  ***********************************************/
void IO_Init(void)
{
    IOP0 = 0x00; //ioλ
    OEP0 = 0xff; //ioڷ 1:out  0:in
    PUP0 = 0x00; //io   1:enable  0:disable
    PDP0 = 0x00; //io   1:enable  0:disable

    IOP1 = 0x00; //ioλ
    OEP1 = 0xff; //ioڷ 1:out  0:in
    PUP1 = 0x00; //io   1:enable  0:disable
    PDP1 = 0x00; //io   1:enable  0:disable

    P0ADCR = 0x00; //˿ģ   1:ģ  0:
    P1ADCR = 0x00; //˿ģ   1:ģ  0:
}
/************************************************
 ;  *    @Function Name       : TIMER1_INT_Init
 ;  *    @Description         : ʱʼ
 ;  *    @IN_Parameter        :
 ;  *    @Return parameter    :
 ;  ***********************************************/
void TIMER1_INT_Init(void)
{
    T1CR = 0x86; //ʹT1ʱΪFCPU64Ƶ
    T1CNT = 125 - 1;
    T1LOAD = 125 - 1; //1mS
    T1IE = 1;
}
/************************************************
;  *    @Function Name       : TIMER2_PWM_Init
;  *    @Description         : ʱʼ
;  *    @IN_Parameter        :
;  *    @Return parameter    :
;  ***********************************************/
void TIMER2_PWM_Init(void)
{
    T2CR = 0x90; //ʹT2ʱΪFPFRCƵ
    T2CNT = 16 - 1;
    T2LOAD = 16 - 1;
    T2DATA = 8;
    T2DATB = 8;
    // ߵƽʱ =T2DATx  T2CNT ʱ
    // ڣT2 ڣ =T2LOAD+1  T2CNT ʱ
    // ռձ = ߵƽʱ /  =T2DATx /T2LOAD+1
    PWM2CR = 0xC0; //PWM2A˿PWM
                   //PWM2B˿PWM
}
/************************************************
;  *    @Function Name       : delay
;  *    @Description         : ʱ
;  *    @IN_Parameter      	 : 
;  *    @Return parameter    :
;  ***********************************************/
void delay(uint8_t num)
{
    for (i = 0; i < num; i++)
    {
        Nop();
        Nop();
        Nop();
        Nop();
        Nop();
        Nop();
        Nop();
        Nop();
        Nop();
        Nop();
    }
}
/************************************************
;  *    @Function Name       : Sys_Init
;  *    @Description         : ϵͳʼ
;  *    @IN_Parameter      	 : 
;  *    @Return parameter    :
;  ***********************************************/
void Sys_Init(void)
{
    GIE = 0;
    CLR_RAM();
    PFRCEN = 1;
    delay(200);           //PFRCENʱ200uSϲӦ
    PFRCR_back = PFRCCAL; //Ƶ΢У׼λ
    PFRCR_temp = 0;
    IO_Init();
    TIMER1_INT_Init();
    TIMER2_PWM_Init();
    GIE = 1;
}
void main(void)
{
    Sys_Init();
    while (1)
    {
        if (FLAG_TIMER1_10ms) //10mS޸һ
        {
            FLAG_TIMER1_10ms = 0;
            PFRCCAL = PFRCR_temp; //޸΢Ĵ
            if (FLAG_PFRCR_ADD_DEC)
            {
                PFRCR_temp--;
                if (PFRCR_temp == 0) //0  ʼ
                {
                    FLAG_PFRCR_ADD_DEC = 0;
                }
            }
            else
            {
                PFRCR_temp++;
                if (PFRCR_temp >= 255) //ӵ255   ʼݼ
                {
                    FLAG_PFRCR_ADD_DEC = 1;
                }
            }
        }
    }
}

void int_isr(void) __interrupt
{
__asm 
    movra _abuf
    swapar _PFLAG
    movra _statusbuf
__endasm;
    if (T1IF && T1IE)
    {
        T1IF = 0;
    __asm 
        MOVAI 10000000B 
        XORRA IOP1
    __endasm;
        //P17ת
        timer1_cnt++;
        if (timer1_cnt >= 10)
        {
            timer1_cnt = 0;
            FLAG_TIMER1_10ms = 1;
        }
    }

__asm 
    swapar _statusbuf
    movra _PFLAG
    swapr _abuf
    swapar _abuf
__endasm;
}
