/******************************************************************************
;  *   	@ͺ				  : MC32P8141
;  *   	@             : 2021.08.04
;  *   	@˾/			  : SINOMCU-FAE
;  *   	@΢֧       : 2048615934
;  *   	@΢           : http://www.sinomcu.com/
;  *   	@Ȩ                 : 2021 SINOMCU˾Ȩ.
;  *----------------------ժҪ---------------------------------
;  *   	   	   	              LVD
            LVDѹΪ3.2V,VDDõѹʱP16Dߣ֮
                        ʹʱעLVD
******************************************************************************/

#include "user.h"

/************************************************
;  *    @Function Name       : CLR_RAM
;  *    @Description         : 
;  *    @IN_Parameter        :
;  *    @Return parameter    :
;  ***********************************************/
void CLR_RAM(void)
{
__asm 
    movai 0x7F 
    movra FSR0
    clrr INDF0
    DJZR FSR0 
    goto $ -2
    clrr INDF0
__endasm;
}
/************************************************
;  *    @Function Name       : IO_Config
;  *    @Description         : ioڳʼ
;  *    @IN_Parameter      	 : 
;  *    @Return parameter    :
;  ***********************************************/
void IO_Init(void)
{
    IOP0 = 0x00; //ioλ
    OEP0 = 0xff; //ioڷ 1:out  0:in
    PUP0 = 0x00; //io   1:enable  0:disable
    PDP0 = 0x00; //io   1:enable  0:disable

    IOP1 = 0x00; //ioλ
    OEP1 = 0xff; //ioڷ 1:out  0:in 
    PUP1 = 0x00; //io   1:enable  0:disable  
    PDP1 = 0x00; //io   1:enable  0:disable

    P0ADCR = 0x00; //˿ģ   1:ģ  0:
    P1ADCR = 0x00; //˿ģ   1:ģ  0:

}
/************************************************
;  *    @Function Name       : LVD_Init
;  *    @Description         : LVD_Initʼ
;  *    @IN_Parameter      	 : 
;  *    @Return parameter    :
;  ***********************************************/
void LVD_Init(void)
{
    LVDCR = 0xA8;       //LVDEN  3.2V
}
/************************************************
;  *    @Function Name       : Sys_Init
;  *    @Description         : ϵͳʼ
;  *    @IN_Parameter      	 : 
;  *    @Return parameter    :
;  ***********************************************/
void Sys_Init(void)
{
    GIE = 0;
    CLR_RAM();
    IO_Init();
    LVD_Init();
    GIE = 1;
}
void main(void)
{
    Sys_Init();
    while (1)
    {
        if(LVDF)        //VDD3.2V
        {
            P16D=1;
        }else
        {
            P16D=0;
        }
        
    }
}

void int_isr(void) __interrupt
{
__asm 
   	movra _abuf
   	swapar _PFLAG
   	movra _statusbuf
__endasm;
    if (INT0IF && INT0IE)
    {
        INT0IF = 0;
__asm 
   	   	MOVAI  	01000000B
   	   	XORRA  	IOP1   	 
__endasm;
   	   	//P16ת
    }
    if (INT1IF && INT1IE)
    {
        INT1IF = 0;
__asm 
   	   	MOVAI  	10000000B
   	   	XORRA  	IOP1   	 
__endasm;
   	   	//P17ת
    }

__asm 
   	swapar _statusbuf
   	movra _PFLAG
   	swapr _abuf
   	swapar _abuf
__endasm;
}
