/******************************************************************************
;  *   	@ͺ				  : MC32P8141
;  *   	@             : 2021.08.04
;  *   	@˾/			  : SINOMCU-FAE
;  *   	@΢֧       : 2048615934
;  *   	@΢           : http://www.sinomcu.com/
;  *   	@Ȩ                 : 2021 SINOMCU˾Ȩ.
;  *----------------------ժҪ---------------------------------
;  *   	   	   	         PWM
                PWM1: P16P17ΣƵ10Kռձ50%ʱ5uS
                PWM2P14P15ΣƵ100Kռձ50%
******************************************************************************/

#include "user.h"

/************************************************
;  *    @Function Name       : CLR_RAM
;  *    @Description         : 
;  *    @IN_Parameter        :
;  *    @Return parameter    :
;  ***********************************************/
void CLR_RAM(void)
{
__asm 
    movai 0x7F 
    movra FSR0
    clrr INDF0
    DJZR FSR0 
    goto $ -2
    clrr INDF0
__endasm;
}
/************************************************
;  *    @Function Name       : IO_Config
;  *    @Description         : ioڳʼ
;  *    @IN_Parameter      	 : 
;  *    @Return parameter    :
;  ***********************************************/
void IO_Init(void)
{
    IOP0 = 0x00; //ioλ
    OEP0 = 0xff; //ioڷ 1:out  0:in
    PUP0 = 0x00; //io   1:enable  0:disable
    PDP0 = 0x00; //io   1:enable  0:disable

    IOP1 = 0x00; //ioλ
    OEP1 = 0xff; //ioڷ 1:out  0:in
    PUP1 = 0x00; //io   1:enable  0:disable
    PDP1 = 0x00; //io   1:enable  0:disable

    P0ADCR = 0x00; //˿ģ   1:ģ  0:
    P1ADCR = 0x00; //˿ģ   1:ģ  0:

}
 /************************************************
 ;  *    @Function Name       : TIMER1_PWM_Init
 ;  *    @Description         : ʱʼ
 ;  *    @IN_Parameter        :
 ;  *    @Return parameter    :
 ;  ***********************************************/
 void TIMER1_PWM_Init(void)
 {
     T1CR = 0xE3;  	//ʹT1ʹPWMʱΪFCPU8Ƶ
     T1CNT = 100-1;
     T1LOAD = 100-1;   	   	//10k
     T1DATA = 50;           //ռձ
    // ߵƽʱ =T1DATA  T1CNT ʱ
    // ڣT1 ڣ =T1LOAD+1  T1CNT ʱ
    // ռձ = ߵƽʱ /  =T1DATA /T1LOAD+1
     PWM1CR0 = 0x0D;    //FPWM1ȡFPWM1˿PWM
   	   	   	   	   	   	//PWM1PWM1˿PWM
     PWM1CR1 = 0x04;    //ʱ5T1ʱ
 }
/************************************************
;  *    @Function Name       : TIMER2_PWM_Init
;  *    @Description         : ʱʼ
;  *    @IN_Parameter        :
;  *    @Return parameter    :
;  ***********************************************/
void TIMER2_PWM_Init(void)
{
    T2CR = 0x80;    //ʹT2ʱΪFCPUƵ
    T2CNT = 80-1;
    T2LOAD = 80-1; 	   	//100k
    T2DATA = 40;
    T2DATB = 40;
    // ߵƽʱ =T2DATx  T2CNT ʱ
    // ڣT2 ڣ =T2LOAD+1  T2CNT ʱ
    // ռձ = ߵƽʱ /  =T2DATx /T2LOAD+1
    PWM2CR = 0xC0;  //PWM2A˿PWM
                    //PWM2B˿PWM
}
/************************************************
;  *    @Function Name       : Sys_Init
;  *    @Description         : ϵͳʼ
;  *    @IN_Parameter      	 : 
;  *    @Return parameter    :
;  ***********************************************/
void Sys_Init(void)
{
    GIE = 0;
    CLR_RAM();
    IO_Init();
    TIMER1_PWM_Init();
    TIMER2_PWM_Init();
    GIE = 1;
}
void main(void)
{
    Sys_Init();
    while (1)
    {
      
    }
}

void int_isr(void) __interrupt
{
__asm 
   	movra _abuf
   	swapar _PFLAG
   	movra _statusbuf
__endasm;



__asm 
   	swapar _statusbuf
   	movra _PFLAG
   	swapr _abuf
   	swapar _abuf
__endasm;
}
