/******************************************************************************
;  *   	@ͺ				  : MC32P8141
;  *   	@             : 2021.08.04
;  *   	@˾/			  : SINOMCU-FAE
;  *   	@΢֧       : 2048615934
;  *   	@΢           : http://www.sinomcu.com/
;  *   	@Ȩ                 : 2021 SINOMCU˾Ȩ.
;  *----------------------ժҪ---------------------------------
;  *   	   	   	        ʱ          
            T0  ڲƵʱ100mS P16ת
            T1  ڲƵʱ10uS  P17ת
            T2  ڲƵʱ1mS   P15ת
******************************************************************************/

#include "user.h"

/************************************************
;  *    @Function Name       : CLR_RAM
;  *    @Description         : 
;  *    @IN_Parameter        :
;  *    @Return parameter    :
;  ***********************************************/
void CLR_RAM(void)
{
__asm 
    movai 0x7F 
    movra FSR0
    clrr INDF0
    DJZR FSR0 
    goto $ -2
    clrr INDF0
__endasm;
}
/************************************************
;  *    @Function Name       : IO_Config
;  *    @Description         : ioڳʼ
;  *    @IN_Parameter      	 : 
;  *    @Return parameter    :
;  ***********************************************/
void IO_Init(void)
{
    IOP0 = 0x00; //ioλ
    OEP0 = 0xff; //ioڷ 1:out  0:in
    PUP0 = 0x00; //io   1:enable  0:disable
    PDP0 = 0x00; //io   1:enable  0:disable

    IOP1 = 0x00; //ioλ
    OEP1 = 0xff; //ioڷ 1:out  0:in
    PUP1 = 0x00; //io   1:enable  0:disable
    PDP1 = 0x00; //io   1:enable  0:disable

    P0ADCR = 0x00; //˿ģ   1:ģ  0:
    P1ADCR = 0x00; //˿ģ   1:ģ  0:

}
/************************************************
;  *    @Function Name       : TIMER0_INT_Init
;  *    @Description         : ʱʼ
;  *    @IN_Parameter      	 : 
;  *    @Return parameter    :
;  ***********************************************/
void TIMER0_INT_Init(void)
{
    T0CR = 0x95; //ʹT0ʱģʽʱΪFLOSC32Ƶ
    T0CNTH = 0;
    T0CNTL=100-1;     //100mS
    T0LOADH = 0;
    T0LOADL = 100-1;    
   	T0IE = 1;
}
 /************************************************
 ;  *    @Function Name       : TIMER1_INT_Init
 ;  *    @Description         : ʱʼ
 ;  *    @IN_Parameter        :
 ;  *    @Return parameter    :
 ;  ***********************************************/
 void TIMER1_INT_Init(void)
 {
     T1CR = 0x80;  	//ʹT1رPWMʱΪFCPUƵ
     T1CNT = 80-1;
     T1LOAD = 80-1;	   	//10uS
     T1IE = 1;
 }
/************************************************
;  *    @Function Name       : TIMER2_INT_Init
;  *    @Description         : ʱʼ
;  *    @IN_Parameter        :
;  *    @Return parameter    :
;  ***********************************************/
void TIMER2_INT_Init(void)
{
    T2CR = 0x86;    //ʹT2ʱΪFCPU64Ƶ
    T2CNT = 125-1;
    T2LOAD = 125-1;	   	//1mS
    T2IE = 1;
}
/************************************************
;  *    @Function Name       : Sys_Init
;  *    @Description         : ϵͳʼ
;  *    @IN_Parameter      	 : 
;  *    @Return parameter    :
;  ***********************************************/
void Sys_Init(void)
{
    GIE = 0;
    CLR_RAM();
    IO_Init();
    TIMER0_INT_Init();
    TIMER1_INT_Init();
    TIMER2_INT_Init();
    GIE = 1;
}
void main(void)
{
    Sys_Init();
    while (1)
    {
      
    }
}

void int_isr(void) __interrupt
{
__asm 
   	movra _abuf
   	swapar _PFLAG
   	movra _statusbuf
__endasm;
    if (T0IF && T0IE)
    {
        T0IF = 0;
__asm 
   	   	MOVAI  	01000000B
   	   	XORRA  	IOP1   	 
__endasm;
   	   	//P16ת
    }
    if (T1IF && T1IE)
    {
        T1IF = 0;
__asm 
   	   	MOVAI  	10000000B
   	   	XORRA  	IOP1   	 
__endasm;
   	   	//P17ת
    }
    if (T2IF && T2IE)
    {
        T2IF = 0;
__asm 
   	   	MOVAI  	00100000B
   	   	XORRA  	IOP1   	 
__endasm;
   	   	//P15ת
    }

__asm 
   	swapar _statusbuf
   	movra _PFLAG
   	swapr _abuf
   	swapar _abuf
__endasm;
}
